<?
# Module: Auth
# count-auth.inc - Access count auth container functions
# Derechos Reservados (c) 2002 Sandino Araico Snchez
# Derechos Reservados (c) 2002 Presidencia de la Repblica
# Copyright (c) 2002 Sandino Araico Snchez All rights reserved

/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE---------------------------------------------------------------
 */
 
# Changelog: 

# 2002-01-05 Sandino Araico Snchez - Limited times access
# 2002-01-11 Sandino Araico Snchez - auth_count_with_exceptions()

if(!defined("__HOPP_COUT_AUTH"))
{
define ("__HOPP_COUT_AUTH",1);
#---------------------------------------------------------------------
include __HOPP_INCLUDE_PATH.'auth/basic-auth.inc';
#---------------------------------------------------------------------
if(!defined('__HOPP_AUTH_COUNT_DEFAULT_MAX'))
	define('__HOPP_AUTH_COUNT_DEFAULT_MAX',3);
#---------------------------------------------------------------------

function auth_count($doc, $defid=0)
{
	if(get_auth_count($doc, $defid))
	{
		echo __HOPP_AUTH_BASIC_REALM.': '.__HOPP_AUTH_BASIC_REALM_UNAUTHORIZED."\n";
		exit;
		//auth_basic_headers_send();
	}
}

function auth_count_with_exceptions($doc, $exceptions, $defid=0)
{
	global $PHP_AUTH_USER;
	
	$id=hopp_db_connected($defid);

	$count=get_auth_count($doc, $id);

	if($count)
	{
		$user=str_replace("'",'',$PHP_AUTH_USER);
		$item=str_replace("'",'',$doc);
		$md5item=md5($doc);
		if((!is_array($exceptions))||(!in_array($user, $exceptions)))
		{
			echo __HOPP_AUTH_BASIC_REALM.': '.__HOPP_AUTH_BASIC_REALM_UNAUTHORIZED."\n";
			exit;
			//auth_basic_headers_send();
		}
		increment_auth_count($user,$md5item,$id);
	}
}

function get_auth_count($doc, $defid=0)
{
	global $PHP_AUTH_USER;
	
	$user=str_replace("'",'',$PHP_AUTH_USER);
	$item=str_replace("'",'',$doc);
	$md5item=md5($doc);
	
	$id=hopp_db_connected($defid);
	hopp_db_start_transaction($id);
	$sql="select h_auth_count_access, h_auth_count_max from h_auth_count where h_auth_count_user='$user' and h_auth_count_item_md5='$md5item'";
	s_log("sql: $sql");
	$result=hopp_db_get_single_row_array_result($id, $sql);
	if(is_array($result))
	{
		$curr=$result['h_auth_count_access'];
		$max=$result['h_auth_count_max'];
		s_log("curr: $curr\tmax: $max");
		if($curr >= $max)
		{
			hopp_db_rollback_transaction($id);
			return 1;
		}	
	}
	else
	{
		$sql="insert into h_auth_count (h_auth_count_user,h_auth_count_item,h_auth_count_item_md5,h_auth_count_access,h_auth_count_max) values ('$user','$item','$md5item',0,".__HOPP_AUTH_COUNT_DEFAULT_MAX.")";
		s_log("sql: $sql");
		hopp_db_exec($id, $sql);
	}
	increment_auth_count($user,$md5item,$id);
	hopp_db_end_transaction($id);
}

function increment_auth_count($user,$md5item,$id)
{
	$sql="update h_auth_count set h_auth_count_access=h_auth_count_access+1 where h_auth_count_user='$user' and h_auth_count_item_md5='$md5item'";
	s_log("sql: $sql");
	hopp_db_exec($id, $sql);
}

#---------------------------------------------------------------------
} //__HOPP_COUT_AUTH

?>
