<?
# HOPP - Hird Of PHP Parts
# Module: fs
# fs.inc 
# Derechos Reservados (c) 2003 Sandino Araico Snchez
# Derechos Reservados (c) 2003 Presidencia de la Repblica
# Copyright (c) 2003 Sandino Araico Snchez All rights reserved
/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE-------------------------------------------------------------$dir$dir--
 */


# Changelog: 
# 2003-02-01 Sandino Araico Snchez - Filesystem Functions
# 2003-02-02 Sandino Araico Snchez - Fixed bugs
# 	Fixed problems with $full_file non-existence
# 2003-02-04 Sandino Araico Snchez - h_fs_check_dir()
# 2003-02-05 Sandino Araico Snchez - Bugfixes

if(!defined('__FILESYSTEM_FUNCTIONS'))
{
define ('__FILESYSTEM_FUNCTIONS',1);
#---------------------------------------------------------------------
include __HOPP_INCLUDE_PATH."mime.inc";
include __HOPP_INCLUDE_PATH."s.inc";
#---------------------------------------------------------------------
define('__FILESYSTEM_TYPE_FILE__',1<<1);
define('__FILESYSTEM_TYPE_DIR__',1<<2);
define('__FILESYSTEM_TYPE_LINK__',1<<3);
define('__FILESYSTEM_TYPE_HIDDEN__',1<<4);
define('__FILESYSTEM_TYPE_THIS__',1<<5);
define('__FILESYSTEM_TYPE_PARENT__',1<<6);
define('__FILESYSTEM_TYPE_OTHER__',1<<7);
define('__FILESYSTEM_TYPE_ALL_VISIBLE__',__FILESYSTEM_TYPE_FILE__|__FILESYSTEM_TYPE_DIR__|__FILESYSTEM_TYPE_LINK__);
define('__FILESYSTEM_TYPE_ALL__', __FILESYSTEM_TYPE_ALL_VISIBLE__|__FILESYSTEM_TYPE_HIDDEN__|__FILESYSTEM_TYPE_THIS__|__FILESYSTEM_TYPE_PARENT__|__FILESYSTEM_TYPE_OTHER__);
#---------------------------------------------------------------------
if(!defined('__FILESYSTEM_MAX_DIR_HOPS'))
	define('__FILESYSTEM_MAX_DIR_HOPS',32);
if(!defined('__FILESYSTEM_DIR_MODE'))	
	define('__FILESYSTEM_DIR_MODE',0755);
#---------------------------------------------------------------------
function h_fs_get_files_from_dir($dir, $show_hidden=0)
{
	return h_fs_get_custom_objects_from_dir($dir,0, __FILESYSTEM_TYPE_FILE__|($show_hidden?__FILESYSTEM_TYPE_HIDDEN__:0));
}

function h_fs_get_links_from_dir($dir, $show_hidden=0)
{
	return h_fs_get_custom_objects_from_dir($dir,0, __FILESYSTEM_TYPE_LINK__|($show_hidden?__FILESYSTEM_TYPE_HIDDEN__:0));
}

function h_fs_get_subdirs_from_dir($dir, $show_hidden=0)
{
	return h_fs_get_custom_objects_from_dir($dir,0, __FILESYSTEM_TYPE_DIR__|($show_hidden?__FILESYSTEM_TYPE_HIDDEN__:0));
}

function h_fs_get_dirs_from_dir($dir, $show_hidden=0)
{
	return h_fs_get_subdirs_from_dir($dir, $show_hidden);
}

function h_fs_get_file_objects_from_dir($dir, $detailed=0, $extra_attrs='', $show_hidden=0)
{
	return h_fs_get_custom_objects_from_dir($dir,1, __FILESYSTEM_TYPE_FILE__|($show_hidden?__FILESYSTEM_TYPE_HIDDEN__:0), $detailed, $extra_attrs);
}
#---------------------------------------------------------------------
function h_fs_get_custom_objects_from_dir($dir, $get_detail=0, $show_types=__FILESYSTEM_TYPE_ALL_VISIBLE__, $detailed=0, $extra_attrs='')
{
	if(!is_dir($dir))
		return 0;
	$handle=opendir($dir);
	if(empty($handle))
		return 0;
	$show_files=$show_types&__FILESYSTEM_TYPE_FILE__;
	$show_dirs=$show_types&__FILESYSTEM_TYPE_DIR__;
	$show_links=$show_types&__FILESYSTEM_TYPE_LINK__;
	$show_hidden=$show_types&__FILESYSTEM_TYPE_HIDDEN__;
	$show_this=$show_types&__FILESYSTEM_TYPE_THIS__;
	$show_parent=$show_types&__FILESYSTEM_TYPE_PARENT__;
	$show_other=$show_types&__FILESYSTEM_TYPE_OTHER__;
	while($file=readdir($handle))
	{
		$full_file="$dir/$file";
		s_log("file: $file",0,0,3);
		s_log("full_file: $full_file",0,0,3);
		if(ereg('^\.',$file))
		{
			if(!$show_this&&($file=='.'))
				continue;
			if(!$show_parent&&($file=='..'))
				continue;
			if(!$show_hidden)
				continue;
		}
		if(is_file($full_file))
		{
			if($show_files)
				$files[]=$file;
			continue;
		}	
		if(is_dir($full_file))
		{
			if($show_dirs)
				$files[]=$file;
			continue;
		}	
		if(is_link($full_file))
		{
			if($show_links)
				$files[]=$file;
			continue;
		}	
		if($show_other)
			$files[]=$file;
	}
	closedir($handle);
	if(is_array($files))
	{
		s_log("Files is array");
		if($get_detail)
		{
			foreach($files as $file)
				$objects[]=h_fs_get_object_from_file($file, $dir, $detailed, $extra_attrs);
			return $objects;
		}	
		else	
			return $files;
	}	
	return 0;	
}

function h_fs_get_object_from_file($file, $dir, $detailed=0, $extra_attrs='')
{
	s_log("dir: $dir\tfile: $file",0,0,3);
	if(empty($file))
		return;
	$full_file=$dir?"$dir/$file":$file;
	s_log("full_file: $full_file",0,0,3);
	if(!file_exists($full_file))
		return;
	$object['FILE']=$file;
	$object['DIR']=$dir;
	$ext=h_mime_get_file_extension($file);
	if(!empty($ext))
		$object['EXT']=$ext;
	$object['FULL_FILE']=$full_file;
	if($detailed>=1)
	{
		$object['SIZE']=filesize($full_file);
		$object['ATIME']=fileatime($full_file);
		$object['CTIME']=filectime($full_file);
		$object['MTIME']=filemtime($full_file);
		$object['TYPE']=filetype($full_file);
		if(!empty($ext))
		{
			$object['WO_EXT']=eregi_replace("\.$ext$",'',$file);
			$object['MIME']=h_mime_get_mime_content_type($ext);
		}
		if($detailed>=2)
		{
			$object['INODE']=fileinode($full_file);
			$object['UID']=fileowner($full_file);
			$object['GID']=filegroup($full_file);
			$mode=fileperms($full_file);
			if($mode)
			{
				$object['MODE']=$mode;
				if($detailed>=3)
					$object['PERMS']=h_fs_get_string_from_mode($mode);
			}
		}
	}
	if(function_exists($extra_attrs))
	{
		$extra_object=$extra_attrs($full_file, $object, $detailed);
		if(is_array($extra_object))
			return $extra_object;
			
	}
	return $object;
}

/*
	Taken from PHP Annotated Manual
	pwalker at pwccanada dot com
	22-Feb-2000 02:00
	Here is a simple function to display UNIX like permissions:
*/
# 2003-02-01 Sandino Araico Snchez 
# 	The function was modified to return a value.
function h_fs_get_string_from_mode($mode)
{
     /* Determine Type */
     if( $mode & 0x1000 )
        $type='p'; /* FIFO pipe */
     else if( $mode & 0x2000 )
        $type='c'; /* Character special */
     else if( $mode & 0x4000 )
        $type='d'; /* Directory */
     else if( $mode & 0x6000 )
      $type='b'; /* Block special */
     else if( $mode & 0x8000 )
        $type='-'; /* Regular */
     else if( $mode & 0xA000 )
        $type='l'; /* Symbolic Link */
     else if( $mode & 0xC000 )
        $type='s'; /* Socket */
    else
        $type='u'; /* UNKNOWN */

     /* Determine permissions */
     $owner["read"]    = ($mode & 00400) ? 'r' : '-';
     $owner["write"]   = ($mode & 00200) ? 'w' : '-';
     $owner["execute"] = ($mode & 00100) ? 'x' : '-';
     $group["read"]    = ($mode & 00040) ? 'r' : '-';
     $group["write"]   = ($mode & 00020) ? 'w' : '-';
     $group["execute"] = ($mode & 00010) ? 'x' : '-';
     $world["read"]    = ($mode & 00004) ? 'r' : '-';
     $world["write"]   = ($mode & 00002) ? 'w' : '-';
     $world["execute"] = ($mode & 00001) ? 'x' : '-';

     /* Adjust for SUID, SGID and sticky bit */
   if( $mode & 0x800 )
        $owner["execute"] = ($owner[execute]=='x') ? 's' : 'S';
     if( $mode & 0x400 )
       $group["execute"] = ($group[execute]=='x') ? 's' : 'S';
     if( $mode & 0x200 )
        $world["execute"] = ($world[execute]=='x') ? 't' : 'T';

	return $type.$owner[read].$owner[write].$owner[execute].$group[read].$group[write].$group[execute].$world[read].$world[write].$world[execute];
}

function h_fs_check_dir($filename, $hops=0)
{
	if($hops>__FILESYSTEM_MAX_DIR_HOPS)
		return;
	if(ereg("\/", $filename))
		$dirname=dirname($filename);
	else
		$dirname=$filename;
	s_log("filename: $filename\tdirname: $dirname\thops: $hops",0,0,3);
	
	if(!file_exists($dirname))
	{
		if(ereg("\/", $dirname))
			h_fs_check_dir($dirname, $hops+1);
		mkdir($dirname, __FILESYSTEM_DIR_MODE);
	}
	return file_exists($dirname);
}

#---------------------------------------------------------------------
} //__FILESYSTEM_FUNCTIONS

?>
